PrefabFiles = {

	"cunyu",
}

Assets = {
	Asset( "ATLAS", "images/cunyu.xml" ),
	Asset("IMAGE", "images/cunyu.tex"), 
	Asset("ANIM", "anim/cunyu.zip"),
	Asset("ANIM", "anim/swap_cunyu.zip"),
}

local RECIPETABS = GLOBAL.RECIPETABS
local Recipe = GLOBAL.Recipe
local Ingredient = GLOBAL.Ingredient
local TECH = GLOBAL.TECH
local TheWorld = GLOBAL.TheWorld
local ACTIONS=GLOBAL.ACTIONS
local FUELTYPE=GLOBAL.FUELTYPE
local SpawnPrefab=GLOBAL.SpawnPrefab
local require = GLOBAL.require
local STRINGS = GLOBAL.STRINGS



 AddPrefabPostInit("cunyu",function(inst)
    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(17)
    inst.components.weapon:SetRange(1.5,1.5)
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(1500)
    inst.components.finiteuses:SetUses(1500)  
    inst.components.finiteuses:SetOnFinished(inst.Remove)
    inst:AddComponent("tool")
	inst.components.tool:SetAction(ACTIONS.NET)
    if inst.components.equippable then inst.components.equippable.walkspeedmult =1.5 end
	local function onattack(weapon, attacker, target)
		if attacker then
			if  target.components.freezable then
				if  target ~= nil and target.components.freezable ~= nil then
					target.components.freezable:AddColdness(1)	
				end	               
			end
		end
	if attacker then
	    if attacker.components.health then
		    attacker.components.health:DoDelta(0)
		end
	end
	if attacker then
	    if attacker.components.sanity then
		    attacker.components.sanity:DoDelta(2)
		end
	end
    end
    inst.components.weapon:SetOnAttack(onattack)
	inst:AddComponent("insulator")
	if "summer"=="summer" then  
		inst.components.insulator:SetSummer()
	else 
		inst.components.insulator:SetWinter()
    end	
	inst.components.insulator:SetInsulation(240)
end)



AddRecipe("cunyu", {Ingredient("bluegem", 2),Ingredient("thulecite_pieces", 20),Ingredient("lightninggoathorn", 2)}, RECIPETABS.WAR, TECH.SCIENCE_TWO, nil, nil, nil, nil, nil, "images/cunyu.xml", "cunyu.tex" )
STRINGS.NAMES.CUNYU="裁雨"
STRINGS.CHARACTERS.GENERIC.CUNYU ="裁雨"
STRINGS.RECIPE_CUNYU= "裁雨"
STRINGS.RECIPE_DESC.CUNYU= "可以斩断雨滴的利刃"

local function OnGetItemFromPlayer(inst, giver, item, player)
    inst.components.weapon:SetDamage(17+inst.mater*10)
	local currentperc = inst.components.finiteuses:GetPercent()
	if item  then
		if  item.prefab == "bluegem" then
			if inst.mater<100 then
				inst.mater = inst.mater+1
				inst.components.weapon:SetDamage(17+inst.mater*10)
				giver.components.talker:Say("等级:"..inst.mater.."/100")
			else
				giver.components.talker:Say("已满级!")
			end
		end
		if item.prefab == "spore_tall" then
			currentperc=currentperc +0.04
		end
		
	end
	if inst.mater >= 100 then
	     inst.components.finiteuses:SetMaxUses(10000000000000000000000000000000)
	end
	if currentperc>=1 then
		currentperc=1
	end
	inst.components.finiteuses:SetPercent(currentperc)
end

local function onpreload(inst, data)
	if data then
		if data.mater then
			inst.mater = data.mater
		end
		OnGetItemFromPlayer(inst)
	end
end

local function onsave(inst, data)
	data.mater = inst.mater
end	

local function OnRefuseItem(inst, giver, item)
	if item then
		giver.components.talker:Say("等级:"..inst.mater.."/".."100")
	end
end

local function AcceptTest(inst, item)
    return item.prefab == "greengem" or item.prefab == "yellowgem" or item.prefab == "orangegem" or 
	item.prefab == "thulecite" or item.prefab == "thulecite_pieces" or item.prefab == "bluegem"
	or item.prefab == "purplegem" or item.prefab == "redgem" or item.prefab == "bluegem"or item.prefab == "spore_tall"
end

AddPrefabPostInit("cunyu",function(inst)
	inst.mater=0
	inst.components.weapon:SetDamage(17)
    inst:ListenForEvent("equipped",OnGetItemFromPlayer)
	inst:AddComponent("trader")
	inst.components.trader:SetAcceptTest(AcceptTest)
	inst.components.trader.onaccept = OnGetItemFromPlayer
	inst.components.trader.onrefuse = OnRefuseItem
	inst.OnSave = onsave
	inst.OnPreLoad = onpreload
end)
AddPrefabPostInit("bluegem",function(inst)
	if not inst.components.tradable then
		inst:AddComponent("tradable")
    end
end)
AddPrefabPostInit("spore_tall",function(inst)
	if not inst.components.tradable then
		inst:AddComponent("tradable")
    end
end)	
